//  Copyright (c) 2015 Razeware LLC. All rights reserved.

import UIKit

class ViewController: UIViewController {
  let card = Card(name: "Taj Mahal", image: UIImage(named:"TajMahal")!)
  var cardViewSetupStarted = false
  
  func createCardNode(#containerRect: CGRect) -> CardNode {
    // Create and configure node
    let cardNode = CardNode(card: card)
    cardNode.backgroundColor = UIColor(white: 1.0, alpha: 0.27)
    cardNode.measure(containerRect.size)
    // Size and position node
    let size = cardNode.calculatedSize
    let origin = containerRect.originForCenteredRectWithSize(size)
    cardNode.frame = CGRect(origin: origin, size: size)
    return cardNode
  }
  
  func addCardViewAsynchronously(#containerRect: CGRect) {
    dispatch_async(dispatch_get_global_queue(QOS_CLASS_BACKGROUND, 0)) {
      let cardNode = self.createCardNode(containerRect: containerRect)
      dispatch_async(dispatch_get_main_queue()) {
        self.view.addSubview(cardNode.view)
      }
    }
  }
  
  override func viewWillLayoutSubviews() {
    super.viewWillLayoutSubviews()
    if !cardViewSetupStarted {
      addCardViewAsynchronously(containerRect: view.bounds)
      cardViewSetupStarted = true
    }
  }
}
